import { applyMiddleware, createStore } from 'redux'
import { createLogger } from 'redux-logger'
import * as persist from 'redux-persist'
import reducer from '../reducers'
import storage from 'redux-persist/lib/storage'
import thunkMiddleware from 'redux-thunk'

// 扩展参数， 可在异步action中获取到
const extraArgs = 'somethings...'

const loggerMiddleware = createLogger({
    colors: {
        action: () => '#03A9F4',
        error: () => '#F20404',
        nextState: () => '#4CAF50',
        prevState: () => '#9E9E9E',
        title: () => 'inherit',
      },
})
const { persistStore, persistReducer } = persist

const persistConfig = {
    key: 'root',
    storage,
}
const persistedReducer = persistReducer(persistConfig, reducer)
export const store = createStore(persistedReducer, applyMiddleware(thunkMiddleware.withExtraArgument(extraArgs), loggerMiddleware))
export const persistor  = persistStore(store)

