
import * as React from 'react'
import { HashRouter as Router, Route, RouteComponentProps } from 'react-router-dom'
import Nav from '../../component/nav'
import { route } from '../../routes'
import Home from '../Home'

interface IRouteItem {
    component: React.ComponentType<RouteComponentProps<any>> | React.ComponentType<any>
    path: string
}

export default class Appcontainer extends React.Component<any, any>{

    constructor (props:any) {
        super(props)
    }
    public render ():JSX.Element {
        return (
            <Router>
                <div>
                    <Nav />
                    <Route path='/' exact={true} component={Home}/>
                    {
                        route.map((item:IRouteItem, index:number) => {
                            return (
                                <Route path={item.path} component={item.component} key={index}/>
                            )
                        })
                    }
                </div>            
            </Router>
        )
    }
}