import * as React from 'react'
import { connect } from 'react-redux'
import { bindActionCreators } from 'redux';
import * as actions from '../../redux/action'
import DecreaseBtn from '../../component/decreaseBtn'
import IncreaseBtn from '../../component/increaseBtn'
import NowValue from '../../component/showValue'
import './index.less'

class Counter extends React.Component<any, any> {
    public componentDidMount () {
        console.log('this.props',this.props)
        let { count } = this.props
        this.props.actions.saveCount(--count)
    }
    public handleDecreaseCB = () => {
        let { count } = this.props
        this.props.saveCount({ count: --count })
    }
    public handleIncreaseCB = () => {
        let { count } = this.props
        this.props.saveCount({ count: ++count })
    }
    public handleChangeCB = (e: any) => {
        const val = e.target.value
        const reg = /^[0-9]*$/
        if (!reg.test(val)) {
            alert('只能输入数字')
            return
        }
        this.props.saveCount({ count: val })
    }
    public render () {
        const { count } = this.props
        return (
            <div className="container">
                <div className="container_count">
                    <DecreaseBtn handleDecrease={this.handleDecreaseCB}/>
                    <NowValue value={count} handleChange={this.handleChangeCB}/>
                    <IncreaseBtn handleIncrease={this.handleIncreaseCB}/>
                    {this.props.children}
                </div>
            </div>
        )    
    }
}

export default connect(
    (state: any) => ({ count: state.count }),
    (dispatch: any) => ({ actions: bindActionCreators(actions, dispatch) })
    // {
    //     saveCount: (payload: any) => ({ type: 'SAVECOUNT', payload }),
    // }
)(Counter)